// ParallelPort.h: interface for the CParallelPort class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARALLELPORT_H__1B0F3FEB_2971_4B5F_8859_048A50435C21__INCLUDED_)
#define AFX_PARALLELPORT_H__1B0F3FEB_2971_4B5F_8859_048A50435C21__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define	PIN_STROBE 1
#define PIN_AUTO   14
#define	PIN_D0	   2
#define	PIN_D1	   3
#define	PIN_D2	   4
#define	PIN_D3	   5
#define	PIN_D4	   6
#define	PIN_D5	   7
#define	PIN_D6	   8
#define	PIN_D7	   9
#define PIN_ERROR  15
#define PIN_INIT   16
#define PIN_SELIN  17
#define PIN_ACK	   10
#define PIN_BUSY   11
#define PIN_PE	   12
#define PIN_SLCT   13


class CParallelPort  
{
public:
	BOOL SetPinLogic(int nPin,BOOL bLogic);
	//ָ,bLogic=1ߵƽ,bLogic=0͵ƽ
	BOOL GetPinLogic(int nPin);//õָŵĵƽ
	BOOL SetPinL(int nPin);//ָΪ͵ƽ
	BOOL SetPinH(int nPin);//ָΪߵƽ
	WriteData(BYTE Data);//дݿ
	BYTE ReadData();//ݿ
	WriteCtrl(BYTE Ctrl);//д
	BYTE ReadCtrl();//
	BYTE ReadState();//״̬
	CString m_strDrivePath;//·
	BYTE m_CtrlByte,m_DataByte,m_StatByte;
	//浱ǰ֣״̬֣
	unsigned short m_nCtrlPort,m_nDataPort,m_nStatPort;//˿ڵַ
	BOOL m_bWin98;//Ƿwin9x
	BOOL InitPort(int nPort=0x378);
	CParallelPort();
	virtual ~CParallelPort();
};

#endif // !defined(AFX_PARALLELPORT_H__1B0F3FEB_2971_4B5F_8859_048A50435C21__INCLUDED_)
